"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.reflect.construct.js");

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

exports.__esModule = true;
exports.RowSearchStrategy = void 0;

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.object.get-prototype-of.js");

var _ArithmeticHelper = require("../interpreter/ArithmeticHelper");

var _binarySearch = require("../interpreter/binarySearch");

var _InterpreterValue = require("../interpreter/InterpreterValue");

var _AdvancedFind2 = require("./AdvancedFind");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var RowSearchStrategy = /*#__PURE__*/function (_AdvancedFind) {
  _inherits(RowSearchStrategy, _AdvancedFind);

  var _super = _createSuper(RowSearchStrategy);

  function RowSearchStrategy(config, dependencyGraph) {
    var _this;

    _classCallCheck(this, RowSearchStrategy);

    _this = _super.call(this, dependencyGraph);
    _this.config = config;
    _this.dependencyGraph = dependencyGraph;
    return _this;
  }

  _createClass(RowSearchStrategy, [{
    key: "find",
    value: function find(key, range, sorted) {
      if (typeof key === 'string') {
        key = (0, _ArithmeticHelper.forceNormalizeString)(key);
      }

      if (range.width() < this.config.binarySearchThreshold || !sorted) {
        var values = this.dependencyGraph.computeListOfValuesInRange(range).map(_InterpreterValue.getRawValue).map(function (arg) {
          return typeof arg === 'string' ? (0, _ArithmeticHelper.forceNormalizeString)(arg) : arg;
        });
        var index = values.indexOf(key);
        return index < 0 ? index : index + range.start.col;
      } else {
        return (0, _binarySearch.rangeLowerBound)(range, key, this.dependencyGraph, 'col');
      }
    }
  }]);

  return RowSearchStrategy;
}(_AdvancedFind2.AdvancedFind);

exports.RowSearchStrategy = RowSearchStrategy;