/**
 * @license
 * Copyright (c) 2021 Handsoncode. All rights reserved.
 */
import { SimpleCellAddress } from '../../Cell';
import { ProcedureAst } from '../../parser';
import { InternalScalarValue } from '../InterpreterValue';
import { ArgumentTypes, FunctionPlugin } from './FunctionPlugin';
export declare class CharPlugin extends FunctionPlugin {
    static implementedFunctions: {
        CHAR: {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        UNICHAR: {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
    };
    char(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    unichar(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
}
