/**
 * @license
 * Copyright (c) 2021 Handsoncode. All rights reserved.
 */
import { SimpleCellAddress } from '../../Cell';
import { ProcedureAst } from '../../parser';
import { FunctionPlugin } from '../index';
import { InternalScalarValue } from '../InterpreterValue';
import { ArgumentTypes } from './FunctionPlugin';
export declare class FormulaTextPlugin extends FunctionPlugin {
    static implementedFunctions: {
        FORMULATEXT: {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
            doesNotNeedArgumentsToBeComputed: boolean;
            isDependentOnSheetStructureChange: boolean;
        };
    };
    /**
     * Corresponds to FORMULATEXT(value)
     *
     * Returns a formula in a given cell as a string.
     *
     * @param ast
     * @param formulaAddress
     */
    formulatext(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
}
