/**
 * @license
 * Copyright (c) 2021 Handsoncode. All rights reserved.
 */
import { SimpleCellAddress } from '../../Cell';
import { ProcedureAst } from '../../parser';
import { InternalScalarValue } from '../InterpreterValue';
import { ArgumentTypes, FunctionPlugin } from './FunctionPlugin';
export declare const PI: number;
export declare class MathConstantsPlugin extends FunctionPlugin {
    static implementedFunctions: {
        PI: {
            method: string;
            parameters: never[];
        };
        SQRTPI: {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
                minValue: number;
            }[];
        };
    };
    pi(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    sqrtpi(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
}
