/**
 * @license
 * Copyright (c) 2021 Handsoncode. All rights reserved.
 */
import { SimpleCellAddress } from '../../Cell';
import { ProcedureAst } from '../../parser';
import { InternalScalarValue } from '../InterpreterValue';
import { ArgumentTypes, FunctionPlugin } from './FunctionPlugin';
export declare class RomanPlugin extends FunctionPlugin {
    static implementedFunctions: {
        ROMAN: {
            method: string;
            parameters: ({
                argumentType: ArgumentTypes;
                minValue: number;
                lessThan: number;
                optionalArg?: undefined;
                defaultValue?: undefined;
            } | {
                argumentType: ArgumentTypes;
                optionalArg: boolean;
                defaultValue: number;
                minValue?: undefined;
                lessThan?: undefined;
            })[];
        };
        ARABIC: {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
    };
    roman(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    arabic(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
}
